#!/bin/bash

# ustawienia domyslne
WEBROOT='/var/www/woe'
API_URL='http://127.0.0.1:7000'
PYTHON_VER=$(python -V 2>&1 | awk -F'[ .]+' '{print $2"."$3}')
#DJANGO_EGG="django_customized-1.3-py${PYTHON_VER}.egg"
DJANGO_TARBALL="lib/Django-1.3.tar.gz"
ETREE_TARBALL="lib/elementtree-1.2.6-20050316.tar.gz"
WWW_EGG="build/www-1.0-py${PYTHON_VER}.egg"

if [ ! -e $(pwd)/${WWW_EGG} ]; then
	./build-eggs.sh
fi

if [ ! -x $(which virtualenv) ]; then
	echo "Brak wymaganego pakietu 'python-virtualenv'"
	exit 1
fi


echo -n "Katalog docelowy [${WEBROOT}]: "
read DIR
if [ ! -z ${DIR} ]; then
	WEBROOT=${DIR}
fi

if [ ! -d $WEBROOT ]; then
	mkdir $WEBROOT 2> /dev/null
	if [ $? -eq 1 ]; then
		echo "Nie udalo sie stworzyc katalogu '${WEBROOT}'"
		exit 1
	fi
fi

echo -n "Adres serwera SOA programu Trawers [${API_URL}]: "
read URL
if [ ! -z ${URL} ]; then
	API_URL=${URL}
fi


SCRIPTS_DIR=$(pwd)

mkdir ${WEBROOT}/mod_wsgi
sed "s#{{WEBROOT}}#${WEBROOT}#" configs/dispatch.wsgi-example |
sed "s#{{PYTHON_VER}}#${PYTHON_VER}#" |
sed "s#{{API_URL}}#${API_URL}#" > ${WEBROOT}/mod_wsgi/dispatch.wsgi

virtualenv --no-site-packages ${WEBROOT}/virtualpy
source ${WEBROOT}/virtualpy/bin/activate

if [ ! -x $(which easy_install) ]; then
	${SCRIPTS_DIR}/ez_setup.py -U setuptools
fi

#easy_install -Z ${SCRIPTS_DIR}/${DJANGO_EGG}
easy_install -Z ${SCRIPTS_DIR}/${WWW_EGG}
easy_install -Z ${SCRIPTS_DIR}/${DJANGO_TARBALL}
easy_install -Z ${SCRIPTS_DIR}/${ETREE_TARBALL}

printf "\n\nPrzykladowa konfiguracja Apache:\n\n"
sed "s#{{WEBROOT}}#${WEBROOT}#g" configs/apache.conf-example
echo


