from django import template
from django.template.defaultfilters import stringfilter

register = template.Library()

@register.filter
@stringfilter
def plmoney(value):
	parts = (str(value).replace('.',',')).split(',')
	if len(parts) != 2:
		return ','.join(parts)
	integral, decimal = parts
	if len(decimal) == 0:
		decimal = '00'
	elif len(decimal) == 1:
		decimal = decimal + '0'
	elif len(decimal) > 2:
		decimal = decimal[:2]
	return ','.join([integral, decimal])
